
unit struvyk;
interface
  type
      vykaz = record
                 pcas:integer; {pocet casti}
                 stru: array[1..10,1..5] of integer;
                 cisla: array[1..250] of real;
               end;
       oper =  record
                  { operand 1}
                  c1,r1,s1:integer;
                  k11,m11,s11,k12,m12,s12:integer;
                  ko:integer; {kod operacie}
                  { operand 2}
                  c2,r2,s2:integer;
                  k21,m21,s21,k22,m22,s22:integer;
                  {vysledok}
                  cv,rv,sv:integer;
                  kv1,mv1,sv1,kv2,mv2,sv2:integer;
                  {opakovanie}
                  nkr:integer;
                  l1,l2,lv: integer;
               end;
      tabop =  record
                 nop:integer;
                 instr: array[1..100] of oper;
               end;
       var _T1TR,  _T2TR:string;

    procedure DoplnTab(var Vyk:vykaz);
    procedure LinToTab(Vyk:vykaz; por:integer; var rr,ss:integer);
    procedure TabToLin(Vyk:vykaz; rr,ss:integer; var por:integer);
    procedure LinToCast(Vyk:vykaz; por:integer; var cc,rr,ss:integer);
    procedure CastToLin(Vyk:vykaz; cc,rr,ss:integer; var lin:integer);
    procedure RedOp(Vyk:vykaz; var T:tabop);
   procedure Zmakni(s:Tabop; var t:vykaz);
   procedure TR(var s1:string; s2:string);
   function transf(ss:string):string;
   function fmt(s1,s2:string):string;

implementation
    procedure DoplnTab(var Vyk:vykaz);
       var
         cast:integer;
       begin
          with Vyk do begin
            stru[1,3]:=0;
            stru[1,4]:=0;
            stru[1,5]:=0;
            for cast:=1 to pcas do begin
                stru[cast+1,3]:=stru[cast,3]+stru[cast,1]*stru[cast,2];
                stru[cast+1,4]:=stru[cast,4]+stru[cast,1];
                stru[cast+1,5]:=stru[cast,5]+stru[cast,2];
            end;
          end;
       end;

    procedure LinToTab(Vyk:vykaz; por:integer; var rr,ss:integer);
      var  cast,i:integer;
      begin
         with Vyk do begin
           if (por<1) or (por>stru[pcas+1,3]) then begin
              rr:=0; ss:=0; exit
           end;
           cast:=1;
           while stru[cast+1,3]<por do cast:=cast+1;
           i:=por-stru[cast,3];
           rr:=((i-1) div stru[cast,2])+1+stru[cast,4];
           ss:=((i-1) mod stru[cast,2])+1+stru[cast,5];
         end;
      end;


    procedure TabToLin(Vyk:vykaz; rr,ss:integer; var por:integer);
      var
         c1,c2,r1,s1:integer;
      begin
        with Vyk do begin
          if (rr<1) or (rr>stru[pcas+1,4]) or
             (ss<1) or (ss>stru[pcas+1,5]) then begin por:=0; exit end;
          c1:=1; while stru[c1+1,4]<rr do c1:=c1+1;
          c2:=1; while stru[c2+1,5]<ss do c2:=c2+1;
{          writeln('c1=',c1:5,' c2=',c2:5);}
          if c1<>c2 then begin por:=0; exit end;
          r1:=rr-stru[c1,4]; s1:=ss-stru[c1,5];
{          writeln(r1:5,s1:5,stru[c1,2]:5,stru[c1,3]:5);}
          por:=stru[c1,3]+(r1-1)*stru[c1,2]+s1;
        end;
    end;

    procedure LinToCast(Vyk:vykaz; por:integer; var cc,rr,ss:integer);
      var  cast,i:integer;
      begin
         with Vyk do begin
           if (por<1) or (por>stru[pcas+1,3]) then begin
              cc:=0; rr:=0; ss:=0; exit
           end;
           cast:=1;
           while stru[cast+1,3]<por do cast:=cast+1;
           i:=por-stru[cast,3];
           cc:=cast;
           rr:=((i-1) div stru[cast,2])+1;
           ss:=((i-1) mod stru[cast,2])+1;
         end;
      end;

    procedure CastToLin(Vyk:vykaz; cc,rr,ss:integer; var lin:integer);
      var
         c1,r1,s1:integer;
      begin
        with Vyk do begin
          c1:=cc; r1:=rr; s1:=ss;
          if (r1<1) or (s1<1) or (r1>stru[c1,1]) or (s1>stru[c1,2])
             then begin lin:=0; exit end;
{          writeln(r1:5,s1:5,stru[c1,2]:5,stru[c1,3]:5);}
          lin:=stru[c1,3]+(r1-1)*stru[c1,2]+s1;
        end;
    end;

    procedure RedOp(Vyk:vykaz; var T:tabop);
        var i: integer;
        begin
            with T do begin
                for i:=1 to Nop do begin
                   with Instr[i] do begin
                      CastToLin(Vyk,c1,r1,s1,l1);
                      CastToLin(Vyk,c2,r2,s2,l2);
                      CastToLin(Vyk,cv,rv,sv,lv);
                   end;
                end;
            end;
        end;

    procedure Urob(o:Oper; var t:vykaz);
       var  ip:integer;
             aa,bb:real;
             ll1,ll2,llv: integer;
       begin
          ll1:=o.l1; ll2:=o.l2; llv:=o.lv;
          for ip:=1 to o.nkr do begin
{             writeln(ll1:5,o.ko:5,ll2:5,' =>', llv:5);}
             aa:=t.cisla[ll1];
             bb:=t.cisla[ll2];
             case o.ko of
             1: t.cisla[llv]:=aa+bb;
             2: t.cisla[llv]:=aa-bb;
             3: t.cisla[llv]:=aa*bb;
             4: t.cisla[llv]:=aa/bb;
             5: t.cisla[llv]:=aa/bb*100
             end;
             with o do begin
             if (ip mod k11=m11) then ll1:=ll1+s11;
             if (ip mod k12=m12) then ll1:=ll1+s12;
             if (ip mod k21=m21) then ll2:=ll2+s21;
             if (ip mod k22=m22) then ll2:=ll2+s22;
             if (ip mod kv1=mv1) then llv:=llv+sv1;
             if (ip mod kv2=mv2) then llv:=llv+sv2;
            end;
         end;
      end;
   procedure Zmakni(s:Tabop; var t:vykaz);
    var ik:integer;
    begin
      for ik:=1 to s.Nop do begin
         urob(s.Instr[ik],t);
      end;
    end;

procedure TR(var s1:string; s2:string);
   var
     i,j,k,l:integer;
   begin
      l:=length(s1);
      for i:=1 to l do s1[i]:=chr(ord(s2[ord(s1[i])]));
   end;


procedure IniTR;
   var
      ii:integer;
      s0,s1,s2:string;
   begin
     s1:='';
     s0:='';
     for ii:=1 to 175 do begin
        s0:=s0+chr(ii);
        if chr(ii) in ['@','\','!','?','>','<','#','$','&']
             then begin
               s2:=chr(ii);
               s1:=s1+chr(pos(s2,'\!?><#$&@'))
             end else s1:=s1+chr(ii+80);
{             writeln(ii:5,' ',chr(ii),' ',s1[ii], ord(s1[ii]):5);
             if ii mod 10=0 then readln;}
         end;
         _T1TR:=s1;
         _T2TR:=s0;
   end;

   function transf(ss:string):string;

     const
       symb='\!?><#$&@';
     var
        ii,jj,kk:integer;
        s0,s1:string;
     begin
       s0:=ss;
       TR(s0,_T1TR);
       kk:=0;
       s1:='';
       for ii:=1 to length(s0) do begin
           case ord(s0[ii]) of
     1..8:
          begin
             jj:=ord(s0[ii])+KK;
             kk:=kk+15;
         end;
     9: begin
            jj:=jj+1
          end;
       else jj:=ord(s0[ii]);
        end;
       s1:=s1+chr(jj);
    end;
    transf:=s1;
end;




   function fmt(s1,s2:string):string;
      var
         ii:integer;
         ss,st:string;
      begin
        st:=s1;
        for ii:=1 to 80 do st:=st+' ';
        ss:=copy(st,1,80)+_t2TR;
        TR(s2,ss);
        fmt:=s2;
    end;




    begin
      IniTR;
    end.